## pure-audio-0.6.tar.gz

=== Makefile ===

# Package name and version number:
dist = pure-audio-$(version)
version = 0.6

# check Makefile.common for compiler flags and platform-specific settings
include Makefile.common

LIBS = -lportaudio -lpthread

# Comment this out to *not* install the realtime module.
realtime = realtime

DISTFILES = COPYING Makefile Makefile.common README \
debian/* examples/*.pure examples/*.pd audio.c audio.pure portaudio.pure \
fftw/Makefile fftw/fftw.c fftw/fftw.pure \
samplerate/Makefile samplerate/srcprocess.c samplerate/srcprocess.h \
samplerate/src.pure samplerate/samplerate.pure \
sndfile/Makefile sndfile/sfinfo.c sndfile/sfinfo.h sndfile/sf.pure \
sndfile/sndfile.pure \
realtime/Makefile realtime/realtime.c realtime/realtime.pure
SEDFILES = README

subdirs = fftw samplerate sndfile $(realtime)

# Makefile to build the PortAudio wrapper and the libsamplerate and libsndfile
# support libraries.

.PHONY: all clean realclean subdirs generate install uninstall dist distcheck

all: audio$(DLL) portaudio.pure subdirs

subdirs:
	for dir in $(subdirs); do $(MAKE) -C $$dir all; done

clean:
	rm -Rf *.o *$(DLL)*
	for dir in $(subdirs); do $(MAKE) -C $$dir clean; done

realclean:
	rm -Rf *.o *$(DLL)* portaudio.pure
	for dir in $(subdirs); do $(MAKE) -C $$dir realclean; done

audio$(DLL): audio.c
	$(CC) $(shared) $(dllname) -o $@ $(MOD_CFLAGS) $< $(MOD_LDFLAGS)

# Type 'make generate' to force a rebuild of the wrappers. This requires
# pure-gen and that you have required header files in the $(includedir)
# directory.

includedir = /usr/include

generate:
	rm -f portaudio.pure
	$(MAKE) portaudio.pure
	$(MAKE) -C samplerate generate
	$(MAKE) -C sndfile generate

portaudio.pure:
ifeq ($(DLL),.dll)
	echo 'using "lib:libportaudio-2.dll";' > $@
	pure-gen -C -ansi -N -m Pa -p Pa -s '$(includedir)/portaudio.h;' $(includedir)/portaudio.h -laudio -o $@
	mv $@ $@.tmp
	tr -d '\r' < $@.tmp > $@
	rm -f $@.tmp
else
	pure-gen -m Pa -p Pa -s '$(includedir)/portaudio.h;' -x '^(linux|unix)$$' $(includedir)/portaudio.h -laudio -o $@
endif

# Type 'make diffs' to generate the wrappers for this platform and compare
# them against the distributed sources.

diffs:
	@$(MAKE) dist > /dev/null
	@rm -rf xxx yyy
	@tar xfz $(dist).tar.gz && mv $(dist) xxx
	@tar xfz $(dist).tar.gz && mv $(dist) yyy
	@rm -f $(dist).tar.gz
	@cd yyy && $(MAKE) generate > /dev/null
	@diff -ru xxx yyy || true
	@rm -rf xxx yyy

install:
	test -d "$(DESTDIR)$(libdir)/pure" || mkdir -p "$(DESTDIR)$(libdir)/pure"
	cp audio.pure portaudio.pure audio$(DLL) fftw/fftw.pure fftw/fftw$(DLL) samplerate/samplerate.pure samplerate/srcprocess$(DLL) sndfile/sndfile.pure sndfile/sfinfo$(DLL) "$(DESTDIR)$(libdir)/pure"
ifneq ($(strip $(realtime)),)
	cp realtime/realtime.pure realtime/realtime$(DLL) "$(DESTDIR)$(libdir)/pure"
endif

uninstall:
	rm -f "$(DESTDIR)$(libdir)/pure/audio.pure" "$(DESTDIR)$(libdir)/pure/portaudio.pure" "$(DESTDIR)$(libdir)/pure/fftw.pure" "$(DESTDIR)$(libdir)/pure/samplerate.pure" "$(DESTDIR)$(libdir)/pure/sndfile.pure" "$(DESTDIR)$(libdir)/pure/audio$(DLL)" "$(DESTDIR)$(libdir)/pure/fftw$(DLL)" "$(DESTDIR)$(libdir)/pure/srcprocess$(DLL)" "$(DESTDIR)$(libdir)/pure/sfinfo$(DLL)"
ifneq ($(strip $(realtime)),)
	rm -f "$(DESTDIR)$(libdir)/pure/realtime.pure" "$(DESTDIR)$(libdir)/pure/realtime$(DLL)"
endif

date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	mkdir $(dist) && mkdir $(dist)/debian && mkdir $(dist)/examples && mkdir $(dist)/fftw && mkdir $(dist)/samplerate && mkdir $(dist)/sndfile && mkdir $(dist)/realtime
	for x in $(DISTFILES); do ln -sf $$PWD/$$x $(dist)/$$x; done
	for x in $(SEDFILES); do rm -f $(dist)/$$x; $(call datesubst,$$PWD/$$x,$(dist)/$$x); done
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && make && make install DESTDIR=./BUILD
	rm -rf $(dist)

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://bitbucket.org/purelang/pure-lang/downloads/$(dist).tar.gz -O $@

=== fftw/Makefile ===

include ../Makefile.common

LIBS = -lfftw3

.PHONY: all clean realclean

all: fftw$(DLL)

clean:
	rm -Rf *.o *$(DLL)*

realclean:
	rm -Rf *.o *$(DLL)*

fftw$(DLL): fftw.c
	$(CC) $(shared) $(dllname) -o $@ $(MOD_CFLAGS) $< $(MOD_LDFLAGS)

=== realtime/Makefile ===

include ../Makefile.common

LIBS = -lpthread

all: realtime$(DLL)

clean:
	rm -Rf *.o *$(DLL)*

realclean:
	rm -Rf *.o *$(DLL)*

realtime$(DLL): realtime.c
	$(CC) $(shared) $(dllname) -o $@ $(MOD_CFLAGS) $< $(MOD_LDFLAGS)

=== samplerate/Makefile ===

include ../Makefile.common

LIBS = -lsamplerate

.PHONY: all clean realclean generate

all: srcprocess$(DLL) samplerate.pure

clean:
	rm -Rf *.o *$(DLL)*

realclean:
	rm -Rf *.o *$(DLL)* samplerate.pure

srcprocess$(DLL): srcprocess.c
	$(CC) $(shared) $(dllname) -o $@ $(MOD_CFLAGS) $< $(MOD_LDFLAGS)

includedir = /usr/include

generate:
	rm -f samplerate.pure
	make samplerate.pure

samplerate.pure: srcprocess.h src.pure
	pure-gen -C -ansi -s '$(includedir)/samplerate.h;' $(includedir)/samplerate.h -lsrcprocess -o $@
	pure-gen -C -ansi -N -s 'srcprocess.h;' srcprocess.h -o $@
	cat src.pure >> $@
ifeq ($(DLL),.dll)
	mv $@ $@.tmp
	tr -d '\r' < $@.tmp > $@
	rm -f $@.tmp
endif

=== sndfile/Makefile ===

include ../Makefile.common

LIBS = -lsndfile

.PHONY: all clean realclean generate

all: sfinfo$(DLL) sndfile.pure

clean:
	rm -Rf *.o *$(DLL)*

realclean:
	rm -Rf *.o *$(DLL)* sndfile.pure

sfinfo$(DLL): sfinfo.c
	$(CC) $(shared) $(dllname) -o $@ $(MOD_CFLAGS) $< $(MOD_LDFLAGS)

includedir = /usr/include

generate:
	rm -f sndfile.pure
	make sndfile.pure

# NOTE: sf_open, sf_open_fd and sf_close are excluded here since we provide
# wrappers for those. (sf_open_virtual is not supported in the Pure wrapper.)

sndfile.pure: sfinfo.h sf.pure
	pure-gen -C -ansi -s '$(includedir)/sndfile.h;' -x '(sf_open|sf_close)'  $(includedir)/sndfile.h -lsfinfo -o $@
	pure-gen -C -ansi -N -s 'sfinfo.h;' sfinfo.h -o $@
	cat sf.pure >> $@
ifeq ($(DLL),.dll)
	mv $@ $@.tmp
	tr -d '\r' < $@.tmp > $@
	rm -f $@.tmp
endif

=== debian/changelog ===
pure-audio (0.5-2) natty; urgency=low

  * Prevent zipping of examples

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 23:32:24 +0200

pure-audio (0.5-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Thu, 24 May 2012 08:15:07 +0200

=== debian/control ===
Source: pure-audio
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure, pure-dev, pure-gen,
 portaudio19-dev, libsndfile1-dev, libsamplerate0-dev, libfftw3-dev
Standards-Version: 3.9.1
Homepage: http://purelang.bitbucket.org

Package: pure-audio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Portable audio interface for the Pure programming language
 Pure is a modern-style functional programming language based on term
 rewriting. This package provides various modules for processing audio data in
 Pure. It currently includes the following modules:
 .
 * audio.pure: A PortAudio wrapper which gives you portable access to realtime
   audio input and output on a variety of different host APIs. This uses the
   well-known PortAudio library by Ross Bencina, Phil Burk et al, see
   http://www.portaudio.com/.
 .
 * fftw.pure: Compute real-valued FFTs of audio signals using Matteo Frigo's
   and Steven G. Johnson's portable and fast FFTW library ("Fastest Fourier
   Transform in the West").
 .
 * sndfile.pure: Reading and writing audio files in various formats. This is a
   fairly straightforward wrapper for Erik de Castro Lopo's libsndfile library,
   see http://www.mega-nerd.com/libsndfile/.
 .
 * samplerate.pure: Perform sample rate conversion on audio data. This uses
   another of Erik's excellent libraries, libsamplerate (a.k.a. SRC), see
   http://www.mega-nerd.com/SRC/.
 .
 * realtime.pure: A little utility module which provides access to realtime
   scheduling to Pure programs. You may need this for low-latency realtime
   audio applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build -- prefix=/usr

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_compress:
	dh_compress -X.pure -X.pd

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

https://bitbucket.org/purelang/pure-lang/downloads/pure-audio-(.*)\.tar\.gz
